<?php
/*
Plugin Name: Sobar pay
Description: SobarPay Plugin for WooCommerce.
Version: 1.1.0
Author: Saidul
Author URI: https://touchsitbd.com

*/

// Include WooCommerce classes
add_action('plugins_loaded', 'custom_payment_init', 0);

function custom_payment_init()
{
    if (class_exists('WC_Payment_Gateway')) {
        require_once('class-custom-payment-gateway.php'); // Define your payment gateway class
    }
}


// Register your custom endpoint for handling callbacks
add_action('init', 'custom_payment_add_endpoint');

function custom_payment_add_endpoint()
{
    add_rewrite_endpoint('custom-payment-callback', EP_ROOT | EP_PAGES);
    add_rewrite_endpoint('custom-payment-callback-cancel', EP_ROOT | EP_PAGES);
}

// Load the custom template for your callback
add_action('template_redirect', 'custom_payment_callback_template');

function custom_payment_callback_template()
{

    if (get_query_var('custom-payment-callback')) {
        $order_id = wc_get_order_id_by_order_key($_GET['key']);
        if ($order_id) {
            WC()->session->__unset('response');
            $order = wc_get_order($order_id);
            $order->update_status('processing', 'Payment is in process.');
            wp_redirect($order->get_checkout_order_received_url());
        }
        // Include your callback handling logic here
        //include(plugin_dir_path(__FILE__) . 'callback-template.php');
        //exit;
    }
    if (get_query_var('custom-payment-callback-cancel')) {
        $order_id = wc_get_order_id_by_order_key($_GET['key']);
        if ($order_id) {
            WC()->session->__unset('response');
            $order = wc_get_order($order_id);
            $order->update_status('cancelled', 'Payment is in process.');
            wp_redirect($order->get_cancel_order_url());
        }
        // Include your callback handling logic here
        //include(plugin_dir_path(__FILE__) . 'callback-template.php');
        //exit;
    }
}






// Add custom columns to the order list table
function custom_admin_order_columns($columns)
{
    $columns['payment_method'] = 'Payment Method';
    $columns['transaction_id'] = 'Transaction ID';
    return $columns;
}
add_filter('manage_edit-shop_order_columns', 'custom_admin_order_columns');

// Populate custom columns with data
function custom_admin_order_column_content($column, $post_id)
{
    if ($column === 'payment_method') {
        echo get_post_meta($post_id, 'Payment Method', true);
    }
    if ($column === 'transaction_id') {
        echo get_post_meta($post_id, 'Transaction ID', true);
    }
}
add_action('manage_shop_order_posts_custom_column', 'custom_admin_order_column_content', 10, 2);


add_filter('plugin_action_links_' . plugin_basename(__FILE__), 'sobar_action_link');

function sobar_action_link($links)
{
    $settings =  '<a href="' . esc_url(get_admin_url(null, 'admin.php?page=wc-settings&tab=checkout')) . '">Settings</a>';
    array_push($links, $settings);
    return $links;
}
